#include "mainwindow.hh"

MainWindow::MainWindow(module_qt_window_s *qt_window, QWidget *parent)
    : QMainWindow(parent)
{
    qt_window->mpv_widget = new MpvWidget(qt_window->queue, qt_window->db, qt_window->reg,
                                          &(qt_window->launched), this);
    connect(qt_window->mpv_widget, &MpvWidget::titleChanged, this, &MainWindow::updateWindowTitle);
    setCentralWidget(qt_window->mpv_widget);
    setFocusPolicy(Qt::StrongFocus);

    connect(this, &MainWindow::emitCloseMpv, this, &MainWindow::__closeMpv,
            Qt::BlockingQueuedConnection);
}

void
MainWindow::closeMpv() noexcept
{
    emit emitCloseMpv();
}

void
MainWindow::__closeMpv()
{
    delete this;
}
